// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_airskin_msgs:msg/AirskinColors.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_airskin_msgs/msg/airskin_colors.h"


#ifndef TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_COLORS__STRUCT_H_
#define TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_COLORS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'idx'
#include "rosidl_runtime_c/primitives_sequence.h"
// Member 'colors'
#include "std_msgs/msg/detail/color_rgba__struct.h"

/// Struct defined in msg/AirskinColors in the package tuw_airskin_msgs.
/**
  * This expresses a set of AirSkin pad colors
 */
typedef struct tuw_airskin_msgs__msg__AirskinColors
{
  /// timestamp in the header is the acquisition time and frame
  std_msgs__msg__Header header;
  /// index of the color in the colors array
  /// if empty the colors array must match the target system
  rosidl_runtime_c__uint16__Sequence idx;
  /// RGBA color values for corresponding AirSkin pads
  std_msgs__msg__ColorRGBA__Sequence colors;
} tuw_airskin_msgs__msg__AirskinColors;

// Struct for a sequence of tuw_airskin_msgs__msg__AirskinColors.
typedef struct tuw_airskin_msgs__msg__AirskinColors__Sequence
{
  tuw_airskin_msgs__msg__AirskinColors * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_airskin_msgs__msg__AirskinColors__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_COLORS__STRUCT_H_
