// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tuw_airskin_msgs:msg/AirskinPressures.idl
// generated code does not contain a copyright notice
#include "tuw_airskin_msgs/msg/detail/airskin_pressures__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `pressures`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
tuw_airskin_msgs__msg__AirskinPressures__init(tuw_airskin_msgs__msg__AirskinPressures * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    tuw_airskin_msgs__msg__AirskinPressures__fini(msg);
    return false;
  }
  // pressures
  if (!rosidl_runtime_c__uint32__Sequence__init(&msg->pressures, 0)) {
    tuw_airskin_msgs__msg__AirskinPressures__fini(msg);
    return false;
  }
  return true;
}

void
tuw_airskin_msgs__msg__AirskinPressures__fini(tuw_airskin_msgs__msg__AirskinPressures * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // pressures
  rosidl_runtime_c__uint32__Sequence__fini(&msg->pressures);
}

bool
tuw_airskin_msgs__msg__AirskinPressures__are_equal(const tuw_airskin_msgs__msg__AirskinPressures * lhs, const tuw_airskin_msgs__msg__AirskinPressures * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // pressures
  if (!rosidl_runtime_c__uint32__Sequence__are_equal(
      &(lhs->pressures), &(rhs->pressures)))
  {
    return false;
  }
  return true;
}

bool
tuw_airskin_msgs__msg__AirskinPressures__copy(
  const tuw_airskin_msgs__msg__AirskinPressures * input,
  tuw_airskin_msgs__msg__AirskinPressures * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // pressures
  if (!rosidl_runtime_c__uint32__Sequence__copy(
      &(input->pressures), &(output->pressures)))
  {
    return false;
  }
  return true;
}

tuw_airskin_msgs__msg__AirskinPressures *
tuw_airskin_msgs__msg__AirskinPressures__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_airskin_msgs__msg__AirskinPressures * msg = (tuw_airskin_msgs__msg__AirskinPressures *)allocator.allocate(sizeof(tuw_airskin_msgs__msg__AirskinPressures), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_airskin_msgs__msg__AirskinPressures));
  bool success = tuw_airskin_msgs__msg__AirskinPressures__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_airskin_msgs__msg__AirskinPressures__destroy(tuw_airskin_msgs__msg__AirskinPressures * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_airskin_msgs__msg__AirskinPressures__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_airskin_msgs__msg__AirskinPressures__Sequence__init(tuw_airskin_msgs__msg__AirskinPressures__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_airskin_msgs__msg__AirskinPressures * data = NULL;

  if (size) {
    data = (tuw_airskin_msgs__msg__AirskinPressures *)allocator.zero_allocate(size, sizeof(tuw_airskin_msgs__msg__AirskinPressures), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_airskin_msgs__msg__AirskinPressures__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_airskin_msgs__msg__AirskinPressures__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_airskin_msgs__msg__AirskinPressures__Sequence__fini(tuw_airskin_msgs__msg__AirskinPressures__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_airskin_msgs__msg__AirskinPressures__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_airskin_msgs__msg__AirskinPressures__Sequence *
tuw_airskin_msgs__msg__AirskinPressures__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_airskin_msgs__msg__AirskinPressures__Sequence * array = (tuw_airskin_msgs__msg__AirskinPressures__Sequence *)allocator.allocate(sizeof(tuw_airskin_msgs__msg__AirskinPressures__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_airskin_msgs__msg__AirskinPressures__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_airskin_msgs__msg__AirskinPressures__Sequence__destroy(tuw_airskin_msgs__msg__AirskinPressures__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_airskin_msgs__msg__AirskinPressures__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_airskin_msgs__msg__AirskinPressures__Sequence__are_equal(const tuw_airskin_msgs__msg__AirskinPressures__Sequence * lhs, const tuw_airskin_msgs__msg__AirskinPressures__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_airskin_msgs__msg__AirskinPressures__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_airskin_msgs__msg__AirskinPressures__Sequence__copy(
  const tuw_airskin_msgs__msg__AirskinPressures__Sequence * input,
  tuw_airskin_msgs__msg__AirskinPressures__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_airskin_msgs__msg__AirskinPressures);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_airskin_msgs__msg__AirskinPressures * data =
      (tuw_airskin_msgs__msg__AirskinPressures *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_airskin_msgs__msg__AirskinPressures__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_airskin_msgs__msg__AirskinPressures__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_airskin_msgs__msg__AirskinPressures__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
