// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_airskin_msgs:msg/AirskinPressures.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_airskin_msgs/msg/airskin_pressures.hpp"


#ifndef TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_PRESSURES__TRAITS_HPP_
#define TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_PRESSURES__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_airskin_msgs/msg/detail/airskin_pressures__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace tuw_airskin_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const AirskinPressures & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: pressures
  {
    if (msg.pressures.size() == 0) {
      out << "pressures: []";
    } else {
      out << "pressures: [";
      size_t pending_items = msg.pressures.size();
      for (auto item : msg.pressures) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const AirskinPressures & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: pressures
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.pressures.size() == 0) {
      out << "pressures: []\n";
    } else {
      out << "pressures:\n";
      for (auto item : msg.pressures) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const AirskinPressures & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_airskin_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_airskin_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_airskin_msgs::msg::AirskinPressures & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_airskin_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_airskin_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_airskin_msgs::msg::AirskinPressures & msg)
{
  return tuw_airskin_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_airskin_msgs::msg::AirskinPressures>()
{
  return "tuw_airskin_msgs::msg::AirskinPressures";
}

template<>
inline const char * name<tuw_airskin_msgs::msg::AirskinPressures>()
{
  return "tuw_airskin_msgs/msg/AirskinPressures";
}

template<>
struct has_fixed_size<tuw_airskin_msgs::msg::AirskinPressures>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_airskin_msgs::msg::AirskinPressures>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_airskin_msgs::msg::AirskinPressures>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_PRESSURES__TRAITS_HPP_
