// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_airskin_msgs:msg/AirskinColors.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_airskin_msgs/msg/airskin_colors.hpp"


#ifndef TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_COLORS__TRAITS_HPP_
#define TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_COLORS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_airskin_msgs/msg/detail/airskin_colors__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'colors'
#include "std_msgs/msg/detail/color_rgba__traits.hpp"

namespace tuw_airskin_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const AirskinColors & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: idx
  {
    if (msg.idx.size() == 0) {
      out << "idx: []";
    } else {
      out << "idx: [";
      size_t pending_items = msg.idx.size();
      for (auto item : msg.idx) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: colors
  {
    if (msg.colors.size() == 0) {
      out << "colors: []";
    } else {
      out << "colors: [";
      size_t pending_items = msg.colors.size();
      for (auto item : msg.colors) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const AirskinColors & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: idx
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.idx.size() == 0) {
      out << "idx: []\n";
    } else {
      out << "idx:\n";
      for (auto item : msg.idx) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: colors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.colors.size() == 0) {
      out << "colors: []\n";
    } else {
      out << "colors:\n";
      for (auto item : msg.colors) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const AirskinColors & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_airskin_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_airskin_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_airskin_msgs::msg::AirskinColors & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_airskin_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_airskin_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_airskin_msgs::msg::AirskinColors & msg)
{
  return tuw_airskin_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_airskin_msgs::msg::AirskinColors>()
{
  return "tuw_airskin_msgs::msg::AirskinColors";
}

template<>
inline const char * name<tuw_airskin_msgs::msg::AirskinColors>()
{
  return "tuw_airskin_msgs/msg/AirskinColors";
}

template<>
struct has_fixed_size<tuw_airskin_msgs::msg::AirskinColors>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_airskin_msgs::msg::AirskinColors>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_airskin_msgs::msg::AirskinColors>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_COLORS__TRAITS_HPP_
