// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_airskin_msgs:msg/AirskinPressures.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_airskin_msgs/msg/airskin_pressures.h"


#ifndef TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_PRESSURES__STRUCT_H_
#define TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_PRESSURES__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'pressures'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/AirskinPressures in the package tuw_airskin_msgs.
/**
  * This expresses a set of AirSkin pad pressures
 */
typedef struct tuw_airskin_msgs__msg__AirskinPressures
{
  /// timestamp in the header is the acquisition time and frame
  std_msgs__msg__Header header;
  /// pressure values of corresponding AirSkin pads
  rosidl_runtime_c__uint32__Sequence pressures;
} tuw_airskin_msgs__msg__AirskinPressures;

// Struct for a sequence of tuw_airskin_msgs__msg__AirskinPressures.
typedef struct tuw_airskin_msgs__msg__AirskinPressures__Sequence
{
  tuw_airskin_msgs__msg__AirskinPressures * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_airskin_msgs__msg__AirskinPressures__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_PRESSURES__STRUCT_H_
